/*
    flc 1999-2002 by NoisyB (noisyb@gmx.net)
    flc lists information about the FILEs (the current directory by default)
    But most important it shows the FILE_ID.DIZ of every file (if present)
    Very useful for FTP Admins or people who have a lot to do with FILE_ID.DIZ
    Copyright (C) 1999-2002 by NoisyB (noisyb@gmx.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <dirent.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include "config.h"
#include "misc.h"
#include "flc.h"
#include "extract.h"


int
extract (st_sub_t *file)
{
  long x = 0;
  struct stat puffer;
  struct dirent *ep;
  DIR *dp;
  char buf[MAXBUFSIZE], buf2[MAXBUFSIZE];
  char property_name[MAXBUFSIZE];
  char cwd[FILENAME_MAX];
  FILE *fh;
  for (x = 0; x < FID_LINES_MAX; x++)
    file->file_id[x][0] = 0;

  strncpy (file->file_id[0], filename_only (file->fullpath), 46);
    file->file_id[0][46] = 0;

  file->checked = 'N';

  if (flc.check)
    {
      sprintf (property_name, "%s_test", &getext (file->fullpath)[1]);
      sprintf (buf, NULL_TO_EMPTY (get_property (flc.configfile, strlwr (property_name), buf2, NULL)), file->fullpath);

      if (buf[0])
        {
          int result = fsystem (stderr, buf);
          sync ();
          file->checked = !result ? 'P' : 'F';
        }
    }

  sprintf (property_name, "%s_extract", &getext (file->fullpath)[1]);
  sprintf (buf, NULL_TO_EMPTY (get_property (flc.configfile, strlwr (property_name), buf2, NULL)), file->fullpath);

  if (!buf[0]) return 0;

  fsystem (stderr, buf);
  sync ();

/*
  file_id.diz stuff here
*/

  if (!(dp = opendir (getcwd (cwd, FILENAME_MAX)))) return -1;

  while ((ep = readdir (dp)) != 0)
    {
      if (!stat (ep->d_name, &puffer))
        if (S_ISREG (puffer.st_mode))
          {
            if (puffer.st_mtime < file->date)
              file->date = puffer.st_mtime;

/*
  read the file_id.diz
*/
            if (!(fh = fopen (ep->d_name, "rb"))) return -1;

            for (x = 0; x < FID_LINES_MAX; x++)
              {
                if (!(fgets (buf, MAXBUFSIZE, fh)))
                  {
                    file->file_id[x][0] = 0;
                    break;
                  }

                stplcr (buf);
                buf[46] = 0;
                strcpy (file->file_id[x], buf[0] ? buf : " ");
              }

            fclose (fh);

            remove (ep->d_name);
          }
    }
  
  return 0;
}
