/*
    flc 1999-2002 by NoisyB (noisyb@gmx.net)
    flc lists information about the FILEs (the current directory by default)
    But most important it shows the FILE_ID.DIZ of every file (if present)
    Very useful for FTP Admins or people who have a lot to do with FILE_ID.DIZ
    Copyright (C) 1999-2002 by NoisyB (noisyb@gmx.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "config.h"
#include "misc.h"
#include "flc.h"
#include "output.h"

int
output (const st_sub_t *file)
{
  int x;
  char buf[MAXBUFSIZE];

  if (!file) return -1;

  if (flc.html)
    fprintf (stdout, "<a href=\"%s\">", file->fullpath);

  fprintf (stdout, "%-12.12s%s %c", 
    file->name,
    flc.html ? "</a>" : "",
    file->checked ?
#ifdef __GNUC__
    file->checked 
#endif    
    : 'N');

  sprintf (buf, flc.kb ? "%6luk%s" : "%7lu%s",
    flc.kb ? (file->size / 1024) : file->size
    ,    "                                            "
    );
  fprintf (stdout, "%-9.9s", buf);

  strftime (buf, 11, "%m-%d-%y   ", localtime (&file->date));
  fprintf (stdout, "%-10.10s", buf);

  for (x = 0; file->file_id[x][0]; x++)
    fprintf (stdout, !x ? "%-45.45s\n" : "                                 %-45.45s\n", file->file_id[x]);

  fflush (stdout);

  return 0;
}
