/*
    flc 1999-2002 by NoisyB (noisyb@gmx.net)
    flc lists information about the FILEs (the current directory by default)
    But most important it shows the FILE_ID.DIZ of every file (if present)
    Very useful for FTP Admins or people who have a lot to do with FILE_ID.DIZ
    Copyright (C) 1999-2002 by NoisyB (noisyb@gmx.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "config.h"
#include "misc.h"
#include "flc.h"
#include "sort.h"

int
sort (st_file_t *file)
{
  st_file_t *file_p;
  st_sub_t sub;
  long sub_size;

  sub_size = sizeof (st_sub_t);
  while (file->next)
    {
      file_p = file->next;

      for (;;)
        {
          if (flc.fr ?
              ((flc.bydate && file->sub.date < file_p->sub.date) ||
               (flc.byname && (file->sub.name)[0] < (file_p->sub.name)[0]) ||
               (flc.bysize && file->sub.size < file_p->sub.size)) :
              ((flc.bydate && file->sub.date > file_p->sub.date) ||
               (flc.byname && (file->sub.name)[0] > (file_p->sub.name)[0]) ||
               (flc.bysize && file->sub.size > file_p->sub.size)))
            {
              memcpy (&sub, &file->sub, sub_size);
              memcpy (&file->sub, &file_p->sub, sub_size);
              memcpy (&file_p->sub, &sub, sub_size);
            }

          if (!file_p->next)
            break;
          file_p = file_p->next;
        }
      file = file->next;
    }

  return 0;
}
