/*
    txtextract.c is part of
    flc 1999-2002 by NoisyB (noisyb@gmx.net)
    flc lists information about the FILEs (the current directory by default)
    But most important it shows the FILE_ID.DIZ of every file (if present)
    Very useful for FTP Admins or people who have a lot to do with FILE_ID.DIZ
    Copyright (C) 1999-2002 by NoisyB (noisyb@gmx.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "config.h"
#include "misc.h"
#include "txtextract.h"

static int txtextract (const char *textfile);

int
main (int argc, char *argv[])
{
  if (argc < 2)
    {
      printf ("USAGE: %s TEXTFILE\n\n"
              "extracts FILE_ID.DIZ from any TEXTFILE\n\n", argv[0]);

      return -1;
    }
  txtextract (argv[1]);

  return 0;
}

int
txtextract (const char *textfile)
{
  char buf[MAXBUFSIZE];
  int found = 0;
  FILE *fh = fopen (textfile, "rb"), *fh2 = 0;

  if (!fh) return -1;

  while ((fgets (buf, MAXBUFSIZE, fh)) != 0)
    {
      if (!strncmp (buf, "@END_FILE_ID.DIZ", 11))
        break;

      if (!strncmp (buf, "@BEGIN_FILE_ID.DIZ", 18))
        {
          if (!(fh2 = fopen ("FILE_ID.DIZ", "wb")))
            {
              fclose (fh);
              return -1;
            }

          found = 1;
        }

      if (found)
        {
          stplcr (buf);
          strcat (buf, "\n");

          fputs ((found == 1) ? (&buf[18]) : buf, fh2);
        }
    }
  fclose (fh);

  if (found)
    fclose (fh2);

  return 0;
}
